
const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let credential = JSON.parse(Mesa.credential.get('shipstation'));
    Mesa.log.info("shipstation credential", credential);
    let authHeader = Mesa.request.base64_encode(`${credential.key}:${credential.secret}`);

    let options = {
      "headers": {
          "Content-Type": "application\/json",
          "Authorization": "Basic " + authHeader,
      }
    }

    let data = vars.loop;    
    for (let item of data.items) {
      for (let i = 0; i < item.options.length; i++) {
        if (item.options[i].name.charAt(0) == '_') {
          delete item.options[i];
        }
      }
    }

    let url = 'https://ssapi.shipstation.com/orders/createorder';
    let results = Mesa.request.post(url, data, options);    

    Mesa.output.next(data);
  }
}